/******************************************************************************

M16/30P UART
2008/09/26
by Sugawara @ r[R

*******************************************************************************/

// wb_̓}CR̎ނɂ킹܂
#include "sfr30p.h"
#include "std_type.h"
#include <string.h>



#ifdef _UART0_
	#define	UARTx_init	UART0_init
	#define	UARTx_txstr	UART0_txstr
	#define	UARTx_txnstr	UART0_txnstr

	#define	UARTx_rxchar	UART0_rxchar
	#define	UARTx_isrx	UART0_isrx
	
	#define	uxmr		u0mr
	#define	uxc0		u0c0
	#define	uxc1		u0c1
	#define	uxbrg		u0brg
	#define	sxric		s0ric
	#define	sxtic		s0tic
	#define	uxtb		u0tb
	#define	uxrb		u0rb
	#define	txd_dir_port	pd6_3
	#define	rxd_dir_port	pd6_2



#endif

// E8ŃfobOꍇɂ UART1͎gpł܂B
#ifdef _UART1_ 
	#define	UARTx_init	UART1_init
	#define	UARTx_txstr	UART1_txstr
	#define	UARTx_txnstr	UART1_txnstr

	#define	UARTx_rxchar	UART1_rxchar
	#define	UARTx_isrx	UART1_isrx
	
	#define	uxmr		u1mr
	#define	uxc0		u1c0
	#define	uxc1		u1c1
	#define	uxbrg		u1brg
	#define	sxric		s1ric
	#define	sxtic		s1tic
	#define	uxtb		u1tb
	#define	uxrb		u1rb
	
	#define	txd_dir_port	pd6_7
	#define	rxd_dir_port	pd6_6
	
	
#endif

#ifdef _UART2_
	#define	UARTx_init	UART2_init
	#define	UARTx_txstr	UART2_txstr
	#define	UARTx_txnstr	UART2_txnstr

	#define	UARTx_rxchar	UART2_rxchar
	#define	UARTx_isrx	UART2_isrx
	
	#define	uxmr		u2mr
	#define	uxc0		u2c0
	#define	uxc1		u2c1
	#define	uxbrg		u2brg
	#define	sxric		s2ric
	#define	sxtic		s2tic
	#define	uxtb		u2tb
	#define	uxrb		u2rb

	#define	txd_dir_port	pd7_0
	#define	rxd_dir_port	pd7_1


#endif


/*===========================================================================
@\̐錾
=============================================================================*/
typedef struct{
	char buf[TXBUFSZ];
	char *pbuf;
	short sz;
}T_BUF;

typedef struct{
	char buf[RXBUFSZ];
	short wp;
	short rp;
	
}T_FIFO;

typedef struct{
	uint8_t txintlevel;
}T_UART_MAN;


/*===========================================================================
@[Jϐ錾
=============================================================================*/
static T_BUF tBufTx;
static T_FIFO tFifoRx;
static T_UART_MAN tUartMan;



/*===========================================================================
@֐vg^Cv錾
=============================================================================*/
void UARTx_txnstr( char far *s ,short len );
static short nextp( short nowp);
static int put_fifo( far char c );



/*------------------------------------------------------------------------
 @\
 	UART@\̏ݒ
 
 	
 	uint8_t rxintlevel	:M荞݃x
 	uint8_t txintlevel	:M荞݃x
 	uint8_t	brr			:rbg[gWX^ݒl
 
 ߂l
 	void
 *------------------------------------------------------------------------*/
void UARTx_init( uint8_t rxintlevel,uint8_t txintlevel ,uint8_t brr)
{
	txd_dir_port = 1;	// TXDx = out
	rxd_dir_port = 0;	// RXDx = in
	
	
	memset( &tBufTx,0,sizeof(tBufTx));
	memset( &tFifoRx,0,sizeof(tFifoRx));
	uxmr = 0x65;
	uxc0 = 0x10;	// CTS/RTS ֎~
	uxc1 = 0x05;
	uxbrg = brr;
	sxric = rxintlevel;
	
	sxtic =0;
	tUartMan.txintlevel = txintlevel;
	
	#ifdef _UART1_
	u1pinsel = 1;
	#endif
	
}


/*------------------------------------------------------------------------
 @\
 	̑MB̒擾Ă̐MB
 
 	
 	char far *s;M
 
 ߂l
 	void
 *------------------------------------------------------------------------*/
void UARTx_txstr( char far *s )
{
	short len;
	len = strlen(s);
	UARTx_txnstr(s,len);
}


/*------------------------------------------------------------------------
 @\
 	w肳ꂽMB
 
 	
 	char far *s;	M
	short len;		
 
 ߂l
 	void
 *------------------------------------------------------------------------*/
void UARTx_txnstr( char far *s ,short len )
{
	while(len){
		while(sxtic & 0x0F );
		if(sizeof(tBufTx.buf) < len){
			tBufTx.sz = sizeof(tBufTx.buf);
		}else{
			tBufTx.sz = len;
		}
		memcpy(tBufTx.buf,s,tBufTx.sz);
		tBufTx.pbuf = &tBufTx.buf[0];
		
		len -= tBufTx.sz ;
		s+=tBufTx.sz;
		
		
		tBufTx.sz--;
		uxtb = *tBufTx.pbuf++;
		
		
		sxtic = tUartMan.txintlevel;
	}
}


/*------------------------------------------------------------------------
 @\
 	fifop̊֐BMobt@̎̃|C^擾
 
 	
	short nowp	݂̃|C^l 
 ߂l
 	
 	short ̃|C^l
 *------------------------------------------------------------------------*/
short nextp( short nowp)
{
	nowp++;
	if(nowp >= sizeof(tFifoRx.buf) ){
		nowp = 0;
	}
	return nowp;
}


/*------------------------------------------------------------------------
 @\
 	MFIFOɕ
 
 	
	char c;FIFOɓ镶 

 ߂l
	int 1:
 		0:s(FIFOt)
 *------------------------------------------------------------------------*/
int put_fifo( char c )
{
	int ret;
	short nxp;
	nxp = nextp(tFifoRx.wp);
	if(nxp != tFifoRx.rp){
		tFifoRx.wp = nxp;
		tFifoRx.buf[tFifoRx.wp] = c;
		ret = 1;
	}else{
		ret = 0;
	}
	return ret;
}


/*------------------------------------------------------------------------
 @\
 	MFIFOɊi[Ăf[^ꕶ擾B
 
 	
	char far *c;f[^i[|C^ 

 ߂l
	int 1:
 		0:s(FIFOt)
 *------------------------------------------------------------------------*/
short UARTx_rxchar( char far *c )
{
	short ret = 0;
	if( tFifoRx.wp != tFifoRx.rp ){
		tFifoRx.rp = nextp(tFifoRx.rp);
		ret = 1;
		*c = tFifoRx.buf[tFifoRx.rp];
	}
	return ret;
}


/*------------------------------------------------------------------------
 @\
 	MFIFOɊi[Ă邩ǂmFB
 
 
	Ȃ

 ߂l
	int 1:f[^
 		0:f[^Ȃ
 *------------------------------------------------------------------------*/
short	UARTx_isrx( void )
{
	return (tFifoRx.wp - tFifoRx.rp );
}




/*------------------------------------------------------------------------
 @\
 	M荞݃nh[
 
 
	Ȃ

 ߂l
	Ȃ
	
	ڐÂƂɂvectԍmF܂B

	
 *------------------------------------------------------------------------*/

#ifdef _UART0_
#pragma interrupt  s0t_int(vect=17)
void s0t_int( void )
#endif

#ifdef _UART1_
#pragma interrupt  s1t_int(vect=19)
void s1t_int( void )
#endif

#ifdef _UART2_
#pragma interrupt  s2t_int(vect=15)
void s2t_int( void )
#endif
{
	if(tBufTx.sz){
		uxtb = *tBufTx.pbuf++;
		tBufTx.sz--;
	}else{
		sxtic = 0x00;
	}
}


/*------------------------------------------------------------------------
 @\
 	M荞݃nh[
 
 
	Ȃ

 ߂l
	Ȃ
	
	ڐÂƂɂvectԍmF܂B

	
 *------------------------------------------------------------------------*/
#ifdef _UART0_
#pragma interrupt  s0r_int(vect=18)
void s0r_int( void )
#endif

#ifdef _UART1_
#pragma interrupt  s1r_int(vect=20)
void s1r_int( void )
#endif

#ifdef _UART2_
#pragma interrupt  s2r_int(vect=16)
void s2r_int( void )
#endif

{
	uint16_t uh;
	uh = uxrb;
	put_fifo(uh);
}


