/***********************************************************************

FILE		:M16_30.c 
DATE		:Sep 29, 2008
DESCRIPTION :main program file.

Copyright(C)@2008 r[R. All rights reserved. 
***********************************************************************/
#include "M16_30.h"

static int check_erase( void );
static void sect_erase( void );
static void sect_write_test( void );
static void dump( void );
static int ram_test( void );
static short get_number( char far * msg );
static short conv_str2number( char far * cmdline);
static void get_address( char far * msg ,char far **adr );
static void conv_str2address( char far *cl,char far **adr);
static uint8_t cnv_char2hex( char c );


static void put_sect_info( void );
static void put_flash_info( void );
static void usage( void );
static void init_m16_30(void) ;

const char far pVer[] = "1.00";

char sstr[100];
char cmdline[80];
volatile uint16_t WaiTim;


/*==============================================================
 @\
  main
  
 
	void
	
 ߂l
	void

 ==============================================================*/
void main(void)
{
	
	uint16_t cmd;
	int rslt;
	long l ;
	char far * p;
	char far * pp;
	char *q;
	char a;
	init_m16_30();
	
	asm("FSET I");				/* 荞݋ */

	UART0_init( 1,1 ,BPS9600);
	UART2_init( 1,1 ,BPS9600);
	
	sprintf(sstr,"M16/30P Be-Con Board (UART%d)\r\n",0);
	UART0_txstr( sstr);
	
	sprintf(sstr,"M16/30P Be-Con Board (UART%d)\r\n",2);
	UART2_txstr( sstr);
	
	FROM_Reset();

	for(;;){
		p1_0 =0;
		Get_cmdline(cmdline,sizeof(cmdline));
		p1_0 =1;
		cmd  = Analyze_cmdline(cmdline);
		switch(cmd){
			case CMD_CHIP_ERASE:
				UART0_txstr("---ChipErase-- \r\n");
				rslt = FROM_ChipErase();
				if(rslt == 1){
					UART0_txstr( "OK\r\n");
					UART0_txstr( "FROM Check memory\r\n");
					rslt = check_erase();
					if(rslt ){
//						UART0_txstr( "OK\r\n");
					}else{
//						UART0_txstr( "NG\r\n");
					}
				}else{
					UART0_txstr( "NG\r\n");
				}
			break;
			
			case CMD_SECT_ERASE:
				UART0_txstr("--SectorErase-- \r\n");
				sect_erase();
			break;
			
			case CMD_RAM_TEST:
				UART0_txstr("--RamTest-- \r\n");
				ram_test();
			break;
			
			case CMD_SECT_WRITE:
				UART0_txstr("--SectorWriteTest--\r\n");
				UART0_txstr(sstr);
				sect_write_test();
			break;
			
			case CMD_SECT_INFO:
				UART0_txstr("--SectorInfo-- \r\n");
				put_sect_info();
			break;
			
			case CMD_FLASH_INFO:
				UART0_txstr("--FlashInfo-- \r\n");
				put_flash_info();
			break;

			case CMD_DUMP:
				dump();
			break;

			case CMD_HELP:
				UART0_txstr("???? HELP \r\n");
				usage();
			break;
			
			case CMD_VER:
				sprintf(sstr,"Ver = %s\r\n",pVer);
				UART0_txstr(sstr);
				break;
			
			case CMD_ERROR:
				UART0_txstr("CMD Error \r\n");
			break;
			
			case CMD_NON:
				UART0_txstr("Please Type command\r\n");
			break;
			
			default:
				UART0_txstr("Error !!\r\n");
			break;
		}
	}

}



/*==============================================================
 @\
  RAMeXg
  
 
	void
	
 ߂l
	1:OK
	0:NG
 ==============================================================*/

int ram_test( void )
{
	void far *ramend;
	uint8_t far *p;
	uint8_t dat;
	
	ramend = RAM_TOP+RAM_SZ;
	
	UART0_txstr("RAM Write...\r\n");
	dat = 0;
	for(p = RAM_TOP;p<(RAM_TOP+RAM_SZ);p++){
		*p = dat++;
	}

	UART0_txstr("RAM Verify...\r\n");
	dat = 0;
	for(p = RAM_TOP;p<(RAM_TOP+RAM_SZ);p++){
		if(*p != dat){
			
			sprintf(sstr,"RAM Verify Error:  %06p: RAM(%02X) DATA(%02X)\r\n  ",p, *p, dat);
			UART0_txstr(sstr);
			goto error_end;
		}
		dat++;
	}
	UART0_txstr("OK\r\n");	
	return 0;
error_end:
	return 1;	
}


/*==============================================================
 @\
  S̈悪폜Ă邩ǂmF
 
 
	void
	
 ߂l
	void

 ==============================================================*/
int check_erase( void )
{
	int rslt = 0;
	uint32_t sz;
	uint8_t far * adr;
	int i;
	int flg ;
	i = 0;
	UART0_txstr("No: Address : size   :status\r\n");
	do{
		adr = FROM_GetSectInfo(i,(uint32_t far *)&sz );
		if( adr != (uint8_t far * )0xFFFFFF){
			sprintf(sstr,"%02d:  %06p: %02X%04X  ",i,adr,(uint16_t)(sz>>16),(uint16_t)sz);
			UART0_txstr(sstr);
			flg = 0;
			while(sz){
			
				if(*adr != 0xFF){
					sprintf(sstr,"NG\r\nMemory not erased :  %06p: %02X\r\n",adr,*adr);
					UART0_txstr(sstr);
					flg =1;
					break;
				}
				adr++;
				sz--;
			}
			if(flg==0){
				UART0_txstr("OK\r\n");
			}
			i++;
		}else{
			UART0_txstr( "end of FROM\r\n");
			rslt = 1; //OK
		}
	}while( adr != (uint8_t far *)0xFFFFFF	 );
	return rslt;
}



/*==============================================================
 @\
 ZN^C[XȀ
 
 
	void
	
 ߂l
	void
	
@ZN^ԍ͌AZN^C[Xs

 ==============================================================*/
void sect_erase( void )
{
	short num;
	uint32_t sz;
	uint8_t far * adr;
	uint8_t far * p;
	int rslt;
	
	num = get_number("input Sector(0-10)?");
	
	adr = FROM_GetSectInfo(num,(uint32_t far *)&sz );
	if(adr != (uint8_t far *)0xFFFFFF ){
		rslt = FROM_SectErase(adr);
		if(rslt){
			for(p = adr; p < (adr+sz);p++){
				if(*p!=0xff){
					sprintf(sstr,"NG\r\nMemory not erased :  %06p: %02X\r\n",p,*p);
					UART0_txstr(sstr);
					rslt = 0;
					break;
				}
			}
		}
		
		if(rslt){
			UART0_txstr("OK\r\n");
		}else{
		}
	}else{
		UART0_txstr("Error illegal Number\r\n");
	}
}



/*==============================================================
 @\
 ZN^݃eXgȀ
 
 
	void
	
 ߂l
	void
	
ZN^ԍ͂ƁÃZN^ɑSԂɏ񂾌
verifyă`FbNB

 ==============================================================*/
void sect_write_test( void )
{
	short num;
	uint32_t sz;
	uint8_t far * adr;
	uint8_t far * p;
	int rslt;
	uint8_t data;
	
	num = get_number("input Sector(0-10)?");
	
	adr = FROM_GetSectInfo(num,(uint32_t far *)&sz );
	if(adr != (uint8_t far *)0xFFFFFF ){

		data = 0;
		for(p = adr; p < (adr+sz);p++){
			rslt = FROM_WriteByte(p,data);
			if(*p!=data){
				sprintf(sstr,"From write error :  %06p: %02X %02X\r\n",p,data,*p);
				UART0_txstr(sstr);
				rslt = 0;
				break;
			}
			data++;
		}

		if(rslt){
			data = 0;
			for(p = adr; p < (adr+sz);p++){
				if(*p!=data){
					sprintf(sstr,"Verify error :  %06p: %02X %02X\r\n",p,data,*p);
					UART0_txstr(sstr);
					rslt = 0;
					break;
				}
				data++;
			}
		}
		
		if(rslt){
			UART0_txstr("OK\r\n");
		}else{
		}
	}else{
		UART0_txstr("Error illegal Number\r\n");
	}
}


 
/*==============================================================
 @\
 dumpR}h
 
 
	void
	
 ߂l
	void
	

@AhX͂āÃAhX 128bytẽ_v\B

 ==============================================================*/
void dump( void )
{
	uint8_t far * adr;
	int i,j;
	
	get_address("input Address(000000-FFFFFF)?",&adr);

	UART0_txstr("address: 00 01 02 03 04 05 06 07  08 09 0A 0B 0C 0D 0E 0F\r\n");
	UART0_txstr("-------+--+--+--+--+--+--+--+--+---+--+--+--+--+--+--+--+\r\n");
	for(i=0;i<8;i++){
		sprintf(sstr,"%p: ",adr);
		UART0_txstr(sstr);
		for(j=0;j<8;j++){
			sprintf(sstr,"%02X ",*adr++);
			UART0_txstr(sstr);
		}
		UART0_txstr(" ");
		for(j=0;j<8;j++){
			sprintf(sstr,"%02X ",*adr++);
			UART0_txstr(sstr);
		}
		UART0_txstr("\r\n");
	}
}




/*==============================================================
 @\
 ZN^̈ꗗ\\
 
 
	void
	
 ߂l
	void
	
@ZN^ʂԍA擪hXATCYAC[XĂ邩ǂ\

 ==============================================================*/
void put_sect_info( void )
{
	uint32_t sz;
	uint8_t far * adr;
	int i;
	int writed;
	
	
	UART0_txstr("No: Address : size   :status\r\n");
	i = 0;
	do{
		adr = FROM_GetSectInfo(i,(uint32_t far *)&sz );
		if( adr != (uint8_t far * )0xFFFFFF){
			sprintf(sstr,"%02d:  %06p: %02X%04X  ",i,adr,(uint16_t)(sz>>16),(uint16_t)sz);
			UART0_txstr(sstr);
			writed = 0;
			while(sz){
				if(*adr != 0xFF){
					writed = 1;
					break;
				}
				adr++;
				sz--;
			}
			if(writed){
				UART0_txstr("Not erased\r\n");
			}else{
				UART0_txstr("Erased \r\n");
			}
			
			i++;
		}else{
		}
	}while( adr != (uint8_t far *)0xFFFFFF	 );
}



/*==============================================================
 @\
 FlashROḾ@Product ID 擾A\
 
 
	void
	
 ߂l
	void

 ==============================================================*/

void put_flash_info( void )
{
	uint8_t data[3];

	FROM_ProductID( &data[0],&data[1],&data[2]);
	sprintf(sstr,"Manufacture Code:%02X:\r\n",data[0]);
	UART0_txstr(sstr);
	sprintf(sstr,"Device Code:%02X:\r\n",data[1]);
	UART0_txstr(sstr);
	sprintf(sstr,"Additional Device Code:%02X:\r\n",data[2]);
	UART0_txstr(sstr);

}


/*==============================================================
 @\
 R}hꗗ\
 
 
	void
	
 ߂l
	void

 ==============================================================*/
void usage( void )
{
	UART0_txstr("== HELP = \r\n");
	UART0_txstr("vr :version\r\n");
	UART0_txstr("ce :chip erase \r\n");
	UART0_txstr("se :sector erase\r\n");
	UART0_txstr("rt :ram test\r\n");
	UART0_txstr("sw :sector write test\r\n");
	UART0_txstr("si :sector infomation\r\n");
	UART0_txstr("fi :FROM Product ID\r\n");
	UART0_txstr("dp :Dump\r\n");
	UART0_txstr("hp or ?:help\r\n");
}



/*==============================================================
 @\
  10i擾 
 
 
	char far * msg :͎ɏo͂镶(bZ[W)

 ߂l
	short : ϊ 

 
   ̓obt@Ƃcmdline gp܂B

 ==============================================================*/
short get_number( char far * msg )
{
	char *adr;
	short num;
	
	UART0_txstr(msg);
	Get_cmdline(cmdline,sizeof(cmdline));
	num = conv_str2number(cmdline);
	return num;
}



/*==============================================================
 @\
  10i̕ shortɕϊB
 
 
	char far * cl:ϊ(10i)

 ߂l
	short : ϊ 


 ==============================================================*/
short conv_str2number( char far *cl)
{
	int inum;
	short num;
	int i;
	
	while((!isalnum(*cl)) && *cl){
		cl++;
	}
	if(*cl){
		if( sscanf(cl,"%d",&inum) ){
			num = inum;
		}else{
			num = 0;
		}
	}else{
		num = 0;
	}
	return num;
}


/*==============================================================
 @\
 AhX擾(16i) 
 
 
	char far * msg :͎ɏo͂镶(bZ[W)
	char far **adr:ϊAhXi[|C^

 ߂l
	char far **adr:ϊAhXi[|C^

 
 ̓obt@Ƃcmdline gp܂B

 ==============================================================*/

void get_address( char far * msg ,char far **adr )
{
	UART0_txstr(msg);
	Get_cmdline(cmdline,sizeof(cmdline));
	conv_str2address(cmdline,adr);
}




/*==============================================================
 @\
 16i̕AhXɕϊB(16i) 
 
 
 	char far *cl:ϊ
 	char far **adr:ϊAhXi[|C^

 ߂l

 ==============================================================*/

void conv_str2address( char far *cl,char far **adr)
{
	int inum;
	short num;
	uint32_t u32;
	int i;
	
	while((!isalnum(*cl)) && *cl){
		cl++;
	}
	if(*cl){
		u32 = 0;
		while(*cl){
			u32 <<= 4;
			u32 += cnv_char2hex(*cl++);
		}
		*adr = (char far *)u32;
	}else{
		*adr = 0;
	}
}



/*==============================================================
 @\
     16iɕϊ@0-9,A-F,a-f 
 
 
	char c :ϊ

 ߂l
 	uint8_t : 0x00`0xF

 ==============================================================*/
uint8_t cnv_char2hex( char c )
{
	uint8_t ret =0;
	if(c >= '0' && c <= '9'){
		ret = c - '0';
		
	}else if( (c>= 'A' && c <= 'F') ||(c>= 'a' && c <= 'f') ){
		ret = toupper(c) -'A' + 10;
	}
	return ret;
}




/*==============================================================
@\
	 M16/30P `bv
 
 
	Ȃ

 ߂l
	Ȃ
	
	ڐÂƂɂvectԍmF܂B
  ==============================================================*/
void init_m16_30(void)
{
	
	prc1 = 1; // veNg
	pm0 = 0x01;
	// PM00,01 g[h
	// PM06 A16-A19L
	prc1 = 0;	// veNg

	
	// CS0 out enable
	// CS1 out enable
	csr = 0x33;

	// Clock [h(ōƂ)
	prc0 = 1;	//veNg
		cm17 = 0;
		cm16 = 0;
		cm07 = 0;
		cm06 = 0;
		cm05 = 0;
	prc0 = 0;	//veNg


	pd1 = b11111111;
	pd4 = b11111111;
	pd5 = b11111111;
	pd6 = b11111111;
	pd7 = b11111111;
	pd8 = b11011111;
	pd9 = b11111111;
	pd10 = b11111111;

	// TimerB2 == 1mSec Interval Timer
	
	tb2mr = b00000000;
	tb2 = 14745;	//about 1mSec 14745.6
	tb2s = 1;
	tb2ic = b00000001;


}




/*------------------------------------------------------------------------
 @\
 	M荞݃nh[
 
 
	Ȃ

 ߂l
	Ȃ
	
	ڐÂƂɂvectԍmF܂B

	
  ------------------------------------------------------------------------*/
#pragma interrupt tb2_int(vect=28)
void tb2_int( void )

{
	if(WaiTim){
		WaiTim--;
	}
}

