/***********************************************************************

FILE		:at49vb.c 
DATE		:Sep 22, 2008
DESCRIPTION :FlashROM(AT49VB040) Driver

ATMEL AT49VB040B dl@(3499B-FLASH-4/06)ɏ]

Copyright(C)@2008 r[R. All rights reserved. 
***********************************************************************/

#include "std_type.h"
#include "at49bv.h"


/*==============================================================
	֐vg^Cv錾
@==============================================================*/
void FROM_ProductID( uint8_t far *  ManuCode,uint8_t far *  DevCode,uint8_t far *  AddDevCode);
int	FROM_Reset(void);
int	FROM_ChipErase(void);
int	FROM_SectErase(uint8_t far * adr);
uint8_t far * FROM_GetSectInfo(int sect,uint32_t far *sectsize);
int	FROM_WriteByte(uint8_t far * adr,uint8_t data);


static int istoggle_bit6( uint8_t dat0,uint8_t dat1 );
static uint8_t get_fval( uint8_t far *  adr );
static void set_fval(uint8_t far * adr,uint8_t val );



/*==============================================================
	ϐ錾
@==============================================================*/

// FLASH ROM ̃ZN^̔ԒnƃTCY
// CS0̃GA 0x30000-0xCFFFF Ȃ̂ŁAFROMANZXɂ̓ZN^4ANZXĂ܂܂B

T_FROM_SECT	const t_from[11]={				
	{(uint8_t far*)(FROM_TOP+0x000000),	0x10000},	/* SECT4 				*/
	{(uint8_t far*)(FROM_TOP+0x010000),	0x10000},	/* SECT5 				*/
	{(uint8_t far*)(FROM_TOP+0x020000),	0x10000},	/* SECT6				*/
	{(uint8_t far*)(FROM_TOP+0x030000),	0x10000},	/* SECT7 				*/
	{(uint8_t far*)(FROM_TOP+0x040000),	0x10000},	/* SECT8 				*/
	
	{(uint8_t far*)(FROM_TOP+0x050000), 0x04000},	/* SECTBOOT				*/
	{(uint8_t far*)(FROM_TOP+0x054000),	0x02000},	/* SECTPARAM1			*/
	{(uint8_t far*)(FROM_TOP+0x056000),	0x02000},	/* SECTPARAM2			*/
	{(uint8_t far*)(FROM_TOP+0x058000),	0x08000},	/* SECT1				*/
	{(uint8_t far*)(FROM_TOP+0x060000),	0x10000},	/* SECT2				*/
	{(uint8_t far*)(FROM_TOP+0x070000),	0x10000},	/* SECT3				*/

};





/*==============================================================
 Toggle Bit Algorithm
 FlashROMɏ݂ɁA҂
 
 1:OK
 0:NG

!! toggle_bit_algorithm Ɋ荞݂ȂǂFROMɃANZX
쓮鋰ꂪ܂B
 /*==============================================================*/
int toggle_bit_algorithm( uint8_t far *adr )
{
	int ret = 0;
	uint8_t dat0,dat1;

	dat1 = get_fval(adr);
	while(ret == 0){
		dat0 = dat1;
		dat1 = get_fval(adr);
		
		if(istoggle_bit6(dat0,dat1) ){
			if(dat1 & BIT5 ){
				dat0 = dat1;
				dat1 = get_fval(adr);
				if(istoggle_bit6(dat0,dat1) ){
					ret = 0;
					break;
				}
			}
		}else{
			ret = 1;
		}
	}
	return ret;
}



/*==============================================================
FlashROM̃v_NgID擾B

uint8_t far * ManuCode    :}jt@N`R[h
uint8_t far * DevCode     :foCXR[h
uint8_t *  far AddDevCode :gfoCXR[h

 ==============================================================*/
void FROM_ProductID( uint8_t far * ManuCode,uint8_t far * DevCode,uint8_t *  far AddDevCode)
{
	// Software Product Identification Entry
	set_fval((uint8_t far *  )(FROM_TOP+0x0555),0xaa);	
	set_fval((uint8_t far *  )(FROM_TOP+0x0AAA),0x55);	
	set_fval((uint8_t far *  )(FROM_TOP+0x0555),0x90);	

	*ManuCode = *(uint8_t far *)FROM_TOP;
	*DevCode = *(uint8_t far * )(FROM_TOP+1);
	*AddDevCode = *(uint8_t far *)(FROM_TOP+3);
	
	// Software Product Identification Exit
	set_fval((uint8_t far * )(FROM_TOP+0x0555),0xaa);	
	set_fval((uint8_t far * )(FROM_TOP+0x0AAA),0x55);	
	set_fval((uint8_t *far  )(FROM_TOP+0x0555),0xf0);	

}


/*==============================================================
Flash ROM Zbg
 1:OK
 0:NG

 ==============================================================*/
int FROM_Reset(void)
{
	int ret;
	set_fval((uint8_t far *)FROM_TOP,0xf0);
	ret = toggle_bit_algorithm((uint8_t far *  )FROM_TOP);
	return ret;	
}

/*==============================================================
`bvC[X
 1:OK
 0:NG

 ==============================================================*/
int FROM_ChipErase(void)
{	
	int ret ;
	set_fval((uint8_t far *)(FROM_TOP+0x0555),0xaa);	
	set_fval((uint8_t far *)(FROM_TOP+0x0aaa),0x55);	
	set_fval((uint8_t far *)(FROM_TOP+0x0555),0x80);	
	set_fval((uint8_t far *)(FROM_TOP+0x0555),0xaa);	
	set_fval((uint8_t far *)(FROM_TOP+0x0aaa),0x55);	
	set_fval((uint8_t far *)(FROM_TOP+0x0555),0x10);	
	ret = toggle_bit_algorithm((uint8_t far * )FROM_TOP);
	return ret;	
}

/*==============================================================
ZN^C[X
ZN^̃|C^
 1:OK
 0:NG

 ==============================================================*/
int FROM_SectErase(uint8_t *adr)
{
	int ret;

	set_fval((uint8_t far *)(FROM_TOP+0x0555),0xaa);	
	set_fval((uint8_t far *)(FROM_TOP+0x0aaa),0x55);	
	set_fval((uint8_t far *)(FROM_TOP+0x0555),0x80);	
	set_fval((uint8_t far *)(FROM_TOP+0x0555),0xaa);	
	set_fval((uint8_t far *)(FROM_TOP+0x0aaa),0x55);	
	set_fval((uint8_t far *)(adr ),0x30);	

	ret = toggle_bit_algorithm((uint8_t far * )FROM_TOP);
	return ret;	
}


/*==============================================================
ZN^擾

int sect				ZN^ԍ(t_fromɒ`Ă鏇)
uint32_t far *sectsize	ZN^̃TCYi[|C^

߂l
uint8_t far * : w肳ꂽZN^ԍł̃ZN^̐擪Ԓn
				ZN^ԍG[̏ꍇɂ͖߂l 0xFFFFFF
				
uint32_t far *sectsize	ZN^̃TCYi[
				G[ɂ͕s

 ==============================================================*/
uint8_t far * FROM_GetSectInfo(int sect,uint32_t far *sectsize)
{
	if(sect<FROM_SCT_MAX){
	  *sectsize=t_from[sect].size;
	  return(t_from[sect].top);
	}else{
	  return((uint8_t far *)0xFFFFFF);	
	}
}



/*==============================================================
1oCg
uint8_t  far * adr:݂Ԓn(FROM)
uint8_t data :݂f[^

߂l
1:I
0:ُI
==============================================================*/
int FROM_WriteByte(uint8_t  far * adr,uint8_t data)
{
uint8_t u;
int ret;

	u = get_fval(adr);
	set_fval((uint8_t far *)(FROM_TOP+0x0555),0xaa);
	set_fval((uint8_t far *)(FROM_TOP+0x0aaa),0x55);
	set_fval((uint8_t far *)(FROM_TOP+0x0555),0xa0);
	set_fval(adr,data);

	ret = toggle_bit_algorithm(adr);
	if(  get_fval(adr) == data ){
		ret = 1;
	}else{
		ret = 0;
	}
	return ret;	


}


/*==============================================================
ubN(Cӂ̃oCg̏)
uint8_t far * adr:݂Ԓn(FROM)
uint8_t far * data :݂f[^ubÑ|C^
uint16_t size:ރTCY

߂l
1:I
0:ُI
==============================================================*/
int FROM_WriteBlock(uint8_t far * adr,uint8_t far * data,uint16_t size)
{
	int ret = 0;
	if(size){
		while(--size){
			if( (ret = FROM_WriteByte(adr ,*data) ) ==0){
				break;
			}
			++adr; ++data;
		}
	}
	return ret;
}


/*==============================================================
 BIT6gOĂ邩@1 toggleĂA 0:toggleĂȂ
 ==============================================================*/
static int istoggle_bit6( uint8_t dat0,uint8_t dat1 )
{
	int ret;
	if( ( (dat0 & BIT6) & (~dat1 & BIT6 ) )
	 || ( (~dat0 & BIT6) & (dat1 & BIT6 ) ) ){
		ret = 1;
	}else{
		ret = 0 ;
	}
	return ret;
}


/*==============================================================
 adrԒn̒l擾B
 œKȂ悤ɂ̂悤ɂĂ܂B
 ==============================================================*/
static uint8_t get_fval( uint8_t far *  adr )
{
	return *adr;
}

/*==============================================================
 adrԒnɒlݒ肷B
 œKȂ悤ɂ̂悤ɂĂ܂B
 ==============================================================*/
static void set_fval(uint8_t far * adr,uint8_t val )
{

	*adr =val;
}
