/***********************************************************************

FILE		:cmdline.c 
DATE		:Sep 29, 2008
DESCRIPTION :console

Copyright(C)@2008 r[R. All rights reserved. 
***********************************************************************/

#include "M16_30.h"


/*===========================================================================
@\̐錾
=============================================================================*/
typedef struct{
	uint8_t cmd;
	const char * str;
}T_CMD;



/*===========================================================================
@萔錾
//@R}hƃR}hԍΏە\
=============================================================================*/
T_CMD const far tCmd[] = {
	{CMD_CHIP_ERASE , "ce"},
	{CMD_SECT_ERASE , "se"},
	{CMD_RAM_TEST   , "rt"},
	{CMD_SECT_WRITE , "sw"},
	{CMD_SECT_INFO  , "si"},
	{CMD_FLASH_INFO , "fi"},
	{CMD_DUMP		, "dp"},
	{CMD_HELP	    , "?"},
	{CMD_HELP	    , "hp"},
	{CMD_VER		, "vr"},
	{CMD_ERROR	    , ""}	// end of struct
};


/*===========================================================================
@֐vg^Cv錾
=============================================================================*/
static void init_m16_30(void) ;
void	Get_cmdline(char *cl,size_t sz);
uint8_t	Analyze_cmdline(char *cl);



/*==============================================================
 @\
  CRM܂ł̕L^B  
 
 	char *cl:	M̊i[
 	size_t sz:	Młő啶
	
 ߂l
 	void
 ==============================================================*/
void	Get_cmdline(char *cl,size_t sz)
{
	int done;
	char ch;
	int cmdp ;
	
	done = 0;
	
	cmdp = 0;
	while(done == 0 ){
		
		if( UART2_rxchar(&ch) ){	// UART2GR[obN
			UART2_txnstr(&ch,1);
		}
		
		if( UART0_rxchar(&ch) ){
			UART0_txnstr(&ch,1);
			switch(ch){
				case 0x0d:
					cl[cmdp] = 0;
					done = 1;
					ch = '\n';
					UART0_txnstr(&ch,1);
					break;
					
				case 0xa:	//܂B
					break;

				case 0x08:	//BS key
					if(cmdp){
						cmdp--;
					}
					break;

				default:
					if(cmdp <sz ){
						cl[cmdp] = ch;
						cmdp++;
					}
					break;
			}
		}
	}
}



/*==============================================================
 @\
  ƈvR}htCmd̒猟B
  
  @
 
 	char *cl:	͂镶
	
 ߂l
 	uint8_t R}hԍ@CMD_CHIP_ERASE Ȃ
 ==============================================================*/
uint8_t	Analyze_cmdline(char *cl)
{
	uint8_t ret = CMD_NON;
	int i;
	
	while((!isprint(*cl)) && *cl){
		cl++;
	}
	if(*cl){
		for(i=0;tCmd[i].cmd != CMD_ERROR;i++){
			if( memcmp(tCmd[i].str,cl,strlen(tCmd[i].str)) == 0 ){
				break;
			}
		}
		ret = tCmd[i].cmd;
		
	}else{
		ret = CMD_NON;
	}
	return ret;
}




